package xyz.tbvns;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.HashMap;
import java.util.concurrent.atomic.AtomicReference;

import static xyz.tbvns.GDConstant.EDITOR_LAYER_PROPERTY_ID;

@NoArgsConstructor
@AllArgsConstructor
public class LevelStringBuilder {
    @Getter
    private StringBuilder levelString;
    @Getter @Setter
    private int editorLayer;

    public LevelStringBuilder add(double ... properties) {
        StringBuilder local = new StringBuilder();
//        for (double s : properties) {
//            local += s + ",";
//        }
        for (int i = 0; i < properties.length; i++) {
            StringBuilder s = new StringBuilder(String.valueOf(properties[i]));
            if (i+1 != properties.length) {
                s.append(",");
            }
            local.append(s);
        }
        if (editorLayer != 0) {
            local.append(",").append(EDITOR_LAYER_PROPERTY_ID).append(",").append(editorLayer);
        }
        local.append(";");
        levelString.append(local);
        return this;
    }

    public LevelStringBuilder add(HashMap<String, String> properties) {
        final AtomicReference<String> local = new AtomicReference<>("");
        properties.forEach((k, v) -> {
            local.set(local.get() + k + "," + v);
        });
        if (editorLayer != 0) {
            local.set(local.get() + EDITOR_LAYER_PROPERTY_ID + "," + editorLayer + ",");
        }
        local.set(removeLastChar(local.get()) + ";");
        levelString.append(local.get());
        return this;
    }

    public static String removeLastChar(String s) {
        return (s == null || s.length() == 0)
                ? null
                : (s.substring(0, s.length() - 1));
    }
}
